/**
 * @class vespa::hosted::athenz::instanceproviderservice::config::AthenzProviderService
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_HOSTED_ATHENZ_INSTANCEPROVIDERSERVICE_CONFIG_ATHENZPROVIDERSERVICE_H
#define CLOUD_CONFIG_VESPA_HOSTED_ATHENZ_INSTANCEPROVIDERSERVICE_CONFIG_ATHENZPROVIDERSERVICE_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::hosted::athenz::instanceproviderservice::config {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalAthenzProviderServiceType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalAthenzProviderServiceType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalAthenzProviderServiceType(const ::config::ConfigValue & __value);
    InternalAthenzProviderServiceType(const ::config::ConfigDataBuffer & __value);
    InternalAthenzProviderServiceType(const ::config::ConfigPayload & __payload);
    InternalAthenzProviderServiceType()  noexcept;
    InternalAthenzProviderServiceType(const InternalAthenzProviderServiceType & __rhs) noexcept;
    InternalAthenzProviderServiceType & operator = (const InternalAthenzProviderServiceType & __rhs) noexcept;
    InternalAthenzProviderServiceType(InternalAthenzProviderServiceType && __rhs) noexcept;
    InternalAthenzProviderServiceType & operator = (InternalAthenzProviderServiceType && __rhs) noexcept;
    ~InternalAthenzProviderServiceType();

    bool operator==(const InternalAthenzProviderServiceType& __rhs) const noexcept;
    bool operator!=(const InternalAthenzProviderServiceType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;


    /** Athenz domain */
    vespalib::string domain;

    /** Athenz service name */
    vespalib::string serviceName;

    /** Secret name of private Key */
    vespalib::string secretName;

    /** Secret version */
    int32_t secretVersion;

    /** Tempory resources */
    vespalib::string sisSecretName; // Default: ""
    int32_t sisSecretVersion; // Default: 0
    vespalib::string sisUrl; // Default: ""

    /** Secret name of CA certificate */
    vespalib::string caCertSecretName;

    /** Certificate DNS suffix */
    vespalib::string certDnsSuffix; // Default: ""

    /** Athenz ZTS server url */
    vespalib::string ztsUrl; // Default: ""

    /** Path to Athenz CA JKS trust store */
    vespalib::string athenzCaTrustStore; // Default: ""

    /** Period between certificate updates */
    int32_t updatePeriodDays; // Default: 1

    /** Tenant Service id */
    vespalib::string tenantService; // Default: "vespa.vespa.tenant"
};

} // namespace internal

typedef internal::InternalAthenzProviderServiceType AthenzProviderServiceConfigBuilder;
typedef const internal::InternalAthenzProviderServiceType AthenzProviderServiceConfig;

} // namespace vespa::hosted::athenz::instanceproviderservice::config
#endif // VESPA_config_VESPA_HOSTED_ATHENZ_INSTANCEPROVIDERSERVICE_CONFIG_ATHENZPROVIDERSERVICE_H
