/**
 * @class vespa::config::content::core::StorBucketdb
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORBUCKETDB_H
#define CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORBUCKETDB_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::content::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalStorBucketdbType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalStorBucketdbType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalStorBucketdbType(const ::config::ConfigValue & __value);
    InternalStorBucketdbType(const ::config::ConfigDataBuffer & __value);
    InternalStorBucketdbType(const ::config::ConfigPayload & __payload);
    InternalStorBucketdbType()  noexcept;
    InternalStorBucketdbType(const InternalStorBucketdbType & __rhs) noexcept;
    InternalStorBucketdbType & operator = (const InternalStorBucketdbType & __rhs) noexcept;
    InternalStorBucketdbType(InternalStorBucketdbType && __rhs) noexcept;
    InternalStorBucketdbType & operator = (InternalStorBucketdbType && __rhs) noexcept;
    ~InternalStorBucketdbType();

    bool operator==(const InternalStorBucketdbType& __rhs) const noexcept;
    bool operator!=(const InternalStorBucketdbType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;


    /** Number of elements to retrieve in one bucket info chunk */
    int32_t bucketinfobatchsize; // Default: 128

    /**
     * Chunk level. Set what level of the path which defines one chunk.
     * (See doxygen info in bucketmanager.h for more info)
     */
    int32_t chunklevel; // Default: 1
};

} // namespace internal

typedef internal::InternalStorBucketdbType StorBucketdbConfigBuilder;
typedef const internal::InternalStorBucketdbType StorBucketdbConfig;

} // namespace vespa::config::content::core
#endif // VESPA_config_VESPA_CONFIG_CONTENT_CORE_STORBUCKETDB_H
