/**
 * @class vespa::config::content::core::StorOpslogger
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STOROPSLOGGER_H
#define CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STOROPSLOGGER_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::content::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalStorOpsloggerType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalStorOpsloggerType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalStorOpsloggerType(const ::config::ConfigValue & __value);
    InternalStorOpsloggerType(const ::config::ConfigDataBuffer & __value);
    InternalStorOpsloggerType(const ::config::ConfigPayload & __payload);
    InternalStorOpsloggerType()  noexcept;
    InternalStorOpsloggerType(const InternalStorOpsloggerType & __rhs) noexcept;
    InternalStorOpsloggerType & operator = (const InternalStorOpsloggerType & __rhs) noexcept;
    InternalStorOpsloggerType(InternalStorOpsloggerType && __rhs) noexcept;
    InternalStorOpsloggerType & operator = (InternalStorOpsloggerType && __rhs) noexcept;
    ~InternalStorOpsloggerType();

    bool operator==(const InternalStorOpsloggerType& __rhs) const noexcept;
    bool operator!=(const InternalStorOpsloggerType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    vespalib::string targetfile; // Default: ""
};

} // namespace internal

typedef internal::InternalStorOpsloggerType StorOpsloggerConfigBuilder;
typedef const internal::InternalStorOpsloggerType StorOpsloggerConfig;

} // namespace vespa::config::content::core
#endif // VESPA_config_VESPA_CONFIG_CONTENT_CORE_STOROPSLOGGER_H
